diff -Nrc2 fontutils-0.5/bzrto/M.depend fontutils-0.6/bzrto/M.depend
*** fontutils-0.5/bzrto/M.depend	Wed Sep  2 17:20:36 1992
--- fontutils-0.6/bzrto/M.depend	Sun Oct 25 14:15:51 1992
***************
*** 11,15 ****
    .././include/types.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h char.h 
  input-ccc.o : input-ccc.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 11,15 ----
    .././include/types.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h char.h input-ccc.h ccc.h 
  input-ccc.o : input-ccc.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 17,21 ****
    .././include/types.h .././include/encoding.h .././include/font.h .././include/bitmap.h \
    .././include/bounding-box.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   char.h .././include/bzr.h .././include/spline.h main.h input-ccc.h 
  main.o : main.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 17,21 ----
    .././include/types.h .././include/encoding.h .././include/font.h .././include/bitmap.h \
    .././include/bounding-box.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   char.h .././include/bzr.h .././include/spline.h input-ccc.h main.h 
  main.o : main.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 24,29 ****
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
    .././include/spline.h .././include/cmdline.h .././include/filename.h .././include/getopt.h \
!   .././include/report.h input-ccc.h char.h main.h .././include/encoding.h metafont.h \
!   oblique.h pstype1.h pstype3.h text.h ccc.h 
  metafont.o : metafont.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 24,29 ----
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
    .././include/spline.h .././include/cmdline.h .././include/filename.h .././include/getopt.h \
!   .././include/report.h input-ccc.h main.h .././include/encoding.h metafont.h \
!   char.h pstype1.h pstype3.h psutil.h text.h ccc.h 
  metafont.o : metafont.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 31,39 ****
    .././include/types.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h char.h .././include/vector.h input-ccc.h metafont.h ccc.h 
! oblique.o : oblique.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
!   .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
!   .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/spline.h .././include/bounding-box.h oblique.h 
  pstype1.o : pstype1.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 31,36 ----
    .././include/types.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h .././include/encoding.h .././include/filename.h .././include/vector.h \
!   char.h input-ccc.h main.h metafont.h ccc.h 
  pstype1.o : pstype1.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 41,46 ****
    .././include/types.h .././include/bounding-box.h .././include/bzr.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h char.h .././include/hexify.h .././include/varstring.h \
!   .././include/vector.h input-ccc.h pstype1.h psutil.h ccc.h 
  pstype3.o : pstype3.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 38,43 ----
    .././include/types.h .././include/bounding-box.h .././include/bzr.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h char.h input-ccc.h .././include/encoding.h .././include/hexify.h \
!   .././include/varstring.h .././include/vector.h pstype1.h psutil.h ccc.h 
  pstype3.o : pstype3.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 48,52 ****
    .././include/types.h .././include/bounding-box.h .././include/bzr.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h pstype3.h psutil.h 
  psutil.o : psutil.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 45,49 ----
    .././include/types.h .././include/bounding-box.h .././include/bzr.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h .././include/encoding.h pstype3.h psutil.h 
  psutil.o : psutil.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 60,63 ****
    .././include/types.h text.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h input-ccc.h char.h 
  version.o : version.c 
--- 57,60 ----
    .././include/types.h text.h .././include/bzr.h .././include/bounding-box.h .././include/font.h \
    .././include/bitmap.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/spline.h input-ccc.h 
  version.o : version.c 
diff -Nrc2 fontutils-0.5/bzrto/README fontutils-0.6/bzrto/README
*** fontutils-0.5/bzrto/README	Wed Mar  4 11:38:03 1992
--- fontutils-0.6/bzrto/README	Mon Oct  5 18:12:41 1992
***************
*** 1,10 ****
! This program converts outline fonts in the homegrown BZR format to a
  form usable for typesetting, such as Metafont or PostScript.
  
  The Metafont file `bzrsetup.mf' is input by the MF code output by this
! program, so mf must be able to find it.  You can generate a font at a
! given size with a command line such as (`$ ' being the shell prompt):
! $ mf '\mode:=localfont; designsize:=24pt#; input foofont'
! To make a 24pt version of foofont.  The default size is 10pt.
  
! The BZR format is described in `../bzr/README'.
--- 1,15 ----
! This program converts outline fonts in our homegrown BZR format to a
  form usable for typesetting, such as Metafont or PostScript.
  
  The Metafont file `bzrsetup.mf' is input by the MF code output by this
! program, so MF must be able to find it.  You can generate a font at a
! given size with a command line such as:
  
!     mf '\mode:=localfont; designsize:=24pt#; input foofont'
! 
! This makes a 24pt version of foofont.  The default size is 10pt.
! 
! Similarly, the Type 3 fonts output by this program use the BuildChar
! routine defined in bzrbuildch.PS.
! 
! The BZR format is described in the manual.
diff -Nrc2 fontutils-0.5/bzrto/bzrsetup.mf fontutils-0.6/bzrto/bzrsetup.mf
*** fontutils-0.5/bzrto/bzrsetup.mf	Wed Sep  2 17:57:33 1992
--- fontutils-0.6/bzrto/bzrsetup.mf	Mon Oct 19 17:03:02 1992
***************
*** 134,140 ****
  def proof_labels (text t) =
    % We need to delimit the arguments here, so \MF\ knows where the
!   % second |text| argument begins.  Our output uses the suffix "e" for
!   % endpoints of segments, and the suffixes "c1" and "c2" for control
!   % points.
    if proofing > 1: general_label (t) (s); fi;
    if proofing > 2: general_label (t) (c1,c2); fi;
--- 134,140 ----
  def proof_labels (text t) =
    % We need to delimit the arguments here, so \MF\ knows where the
!   % second |text| argument begins.  Our output uses the suffix |"s"| for
!   % startpoints of segments, and the suffixes |"c1"| and |"c2"| for
!   % control points.
    if proofing > 1: general_label (t) (s); fi;
    if proofing > 2: general_label (t) (c1,c2); fi;
***************
*** 163,167 ****
  def fill_or_unfill expr p =
    temp_path := p;
-   loggingall;
    if turningnumber temp_path > 0: fill else: unfill fi temp_path;
  enddef;
--- 163,166 ----
diff -Nrc2 fontutils-0.5/bzrto/ccc.y fontutils-0.6/bzrto/ccc.y
*** fontutils-0.5/bzrto/ccc.y	Tue Sep  1 14:46:19 1992
--- fontutils-0.6/bzrto/ccc.y	Sun Oct 11 16:03:33 1992
***************
*** 30,38 ****
  
  
! /* Retrieve the TFM dimension specified by the accessor macro TFM_DIMEN in
!    the character CHAR_PTR.  Assume both the CHAR_PTR and the TFM info in the
!    character exist.  */
! #define BZR_TFM_DIMEN(tfm_dimen, bzr_char_ptr)				\
!   tfm_dimen (*CHAR_TFM_INFO (*(bzr_char_ptr)))
  
  
--- 30,41 ----
  
  
! /* Set the return value RET to either the dimension DIM, if NAME is a
!    valid character name, or an invalid sentinel.  Used in the
!    `unit_of_measure' rule.  */
! #define DO_CHAR_DIMEN(ret, dimen, name)					\
!   if (char_known_p (name))						\
!     ret = dimen_init (dimen);						\
!   else									\
!     DIMEN_VALID (ret) = false
  
  
***************
*** 124,128 ****
                        DIMEN_ABSOLUTE ($$) = true;
                      }
- 
                  | TR_CAPHEIGHT  { $$ = dimen_init (ccc_fontinfo.cap_height); }
                  | TR_DESIGNSIZE { $$ = dimen_init (ccc_fontinfo.design_size); }
--- 127,130 ----
***************
*** 130,174 ****
                  | TR_FONTDEPTH  { $$ = dimen_init (ccc_fontinfo.font_depth); }
                  | TR_XHEIGHT    { $$ = dimen_init (ccc_fontinfo.xheight); }
! 
!                 | TR_HEIGHT '(' T_CHARNAME ')'	
                      {
!                       if (char_known_p ($3))
!                         $$ = dimen_init (BZR_TFM_DIMEN (TFM_HEIGHT,
!                                                         chars[$3.code]));
!                       else
!                         DIMEN_VALID ($$) = false;
                      }
  		| TR_WIDTH '(' T_CHARNAME ')'
                      {
!                       if (char_known_p ($3))
!                         $$ = dimen_init (BZR_TFM_DIMEN (TFM_WIDTH,
!                                                         chars[$3.code]));
!                       else
!                         DIMEN_VALID ($$) = false;
                      }
  		| TR_DEPTH '(' T_CHARNAME ')'
                      {
!                       if (char_known_p ($3))
!                         $$ = dimen_init (BZR_TFM_DIMEN (TFM_DEPTH,
!                                                         chars[$3.code]));
!                       else
!                         DIMEN_VALID ($$) = false;
                      }
                  | TR_BBHEIGHT '(' T_CHARNAME ')'	
                      {
!                       if (char_known_p ($3))
!                         $$ = dimen_init (BB_HEIGHT (BCHAR_BB
!                                                      (*chars[$3.code])));
!                       else
!                         DIMEN_VALID ($$) = false;
                      }
- 		;
                  | TR_BBWIDTH '(' T_CHARNAME ')'	
                      {
!                       if (char_known_p ($3))
!                         $$ = dimen_init (BB_WIDTH (BCHAR_BB
!                                                     (*chars[$3.code])));
!                       else
!                         DIMEN_VALID ($$) = false;
                      }
  		;
--- 132,156 ----
                  | TR_FONTDEPTH  { $$ = dimen_init (ccc_fontinfo.font_depth); }
                  | TR_XHEIGHT    { $$ = dimen_init (ccc_fontinfo.xheight); }
!                 | TR_HEIGHT '(' T_CHARNAME ')'
                      {
!                       DO_CHAR_DIMEN ($$, CHAR_HEIGHT (*chars[$3.code]), $3);
                      }
  		| TR_WIDTH '(' T_CHARNAME ')'
                      {
!                       DO_CHAR_DIMEN ($$, CHAR_SET_WIDTH (*chars[$3.code]), $3);
                      }
  		| TR_DEPTH '(' T_CHARNAME ')'
                      {
!                       DO_CHAR_DIMEN ($$, CHAR_DEPTH (*chars[$3.code]), $3);
                      }
                  | TR_BBHEIGHT '(' T_CHARNAME ')'	
                      {
!                       DO_CHAR_DIMEN
!                         ($$, BB_HEIGHT (CHAR_BB (*chars[$3.code])), $3);
                      }
                  | TR_BBWIDTH '(' T_CHARNAME ')'	
                      {
!                       DO_CHAR_DIMEN
!                         ($$, BB_WIDTH (CHAR_BB (*chars[$3.code])), $3);
                      }
  		;
***************
*** 393,398 ****
  }
  
! /* Return true if the character C is defined in both the BZR and the TFM
!    input fonts, otherwise false.  If it is undefined, give a warning.  */
  
  static boolean
--- 375,379 ----
  }
  
! /* Return true if the character C is defined; otherwise, give a warning.  */
  
  static boolean
***************
*** 402,409 ****
    
    if (chars[c.code] == NULL)
!     CCC_WARN2 ("Character %d (%s) undefined in BZR files", c.code, c.name);
! 
!   else if (CHAR_TFM_INFO (*chars[c.code]) == NULL)
!     CCC_WARN2 ("Character %d (%s) undefined in TFM files", c.code, c.name);
  
    else
--- 383,387 ----
    
    if (chars[c.code] == NULL)
!     CCC_WARN2 ("Character %d (%s) undefined", c.code, c.name);
  
    else
diff -Nrc2 fontutils-0.5/bzrto/char.c fontutils-0.6/bzrto/char.c
*** fontutils-0.5/bzrto/char.c	Mon Aug 31 10:50:54 1992
--- fontutils-0.6/bzrto/char.c	Mon Oct 19 10:24:33 1992
***************
*** 24,77 ****
  
  #include "char.h"
-  
- static void scale_splines (spline_list_array_type *shape, real scale_factor);
- static real_coordinate_type scale_point (real_coordinate_type, real);
- static void scale_bzr_char (bzr_char_type *c, real scale_factor);
- static void scale_tfm_char (tfm_char_type *c, real scale_factor);
- 
- char_type *
- get_new_char (charcode_type code)
- {
-   char_type *new_char;
-   bzr_char_type *bzr_info = bzr_get_char (code);
-   tfm_char_type *tfm_info = tfm_get_char (code);
  
!   if (bzr_info == NULL)
!     return NULL;
  
-   /* OK, we'll have a character to return.  Fill in the `char_type'
-      structure.  */
-   new_char = XTALLOC1 (char_type);
-   
-   CHAR_BZR_INFO (*new_char) = bzr_info;
-   CHAR_TFM_INFO (*new_char) = tfm_info;
  
!   return new_char;
! }
  
! /* Scale the BZR and TFM information in C by SCALE_FACTOR.  */
  
  void
! scale_char (char_type *c, real scale_factor)
  {
!   if (scale_factor != 1)
!     {
!       scale_bzr_char (CHAR_BZR_INFO (*c), scale_factor);
!       scale_tfm_char (CHAR_TFM_INFO (*c), scale_factor);
!     }
! }
! 
! 
! /* Scale the set width, bounding box, and splines in C by SCALE_FACTOR.  */
  
- static void
- scale_bzr_char (bzr_char_type *c, real scale_factor)
- {
    CHAR_SET_WIDTH (*c) *= scale_factor;
!   BZR_CHAR_MIN_COL(*c) *= scale_factor;
!   BZR_CHAR_MAX_COL(*c) *= scale_factor;
!   BZR_CHAR_MIN_ROW(*c) *= scale_factor;
!   BZR_CHAR_MAX_ROW(*c) *= scale_factor;
!   scale_splines (&(BZR_SHAPE (*c)), scale_factor);
  }
  
--- 24,57 ----
  
  #include "char.h"
  
! #include "ccc.h"
  
  
! /* Angle from the vertical by which to slant the shapes, in radians.
!    (-oblique-angle)  */
! real oblique_angle = 0.0;
! 
! 
! static void scale_splines (spline_list_array_type *shape, real scale_factor);
! static real_coordinate_type scale_point (real_coordinate_type, real);
! static real_coordinate_type slant_point (real_coordinate_type);
! static unsigned update_subrs
!   (char_type *[], charcode_type, ccc_type *[], bzr_char_type *[]);
  
! /* Scale the information in C by SCALE_FACTOR.  */
  
  void
! scale_char (bzr_char_type *c, real scale_factor)
  {
!   if (scale_factor == 1)
!     return;
  
    CHAR_SET_WIDTH (*c) *= scale_factor;
!   CHAR_MIN_COL(*c) *= scale_factor;
!   CHAR_MAX_COL(*c) *= scale_factor;
!   CHAR_MIN_ROW(*c) *= scale_factor;
!   CHAR_MAX_ROW(*c) *= scale_factor;
! 
!   scale_splines (&BZR_SHAPE (*c), scale_factor);
  }
  
***************
*** 122,179 ****
    return scaled_p;
  }
  
  
! /* Scale all the character dimensions in C by SCALE_FACTOR.  */
  
! static void
! scale_tfm_char (tfm_char_type *c, real scale_factor)
  {
!   unsigned this_kern;
!   list_type kern_table;
    
!   /* If things are confused, the TFM file may not have the same
!      characters defined as the BZR file.  */
!   if (c == NULL)
!     return;
!     
!   kern_table = TFM_KERN (*c);
    
!   for (this_kern = 0; this_kern < LIST_SIZE (kern_table); this_kern++)
      {
!       tfm_kern_type *kern = LIST_ELT (kern_table, this_kern);
        
!       kern->kern *= scale_factor;
      }
  
!   TFM_WIDTH (*c) *= scale_factor;
!   TFM_HEIGHT (*c) *= scale_factor;
!   TFM_FIX_WIDTH (*c) *= scale_factor;
!   TFM_FIX_HEIGHT (*c) *= scale_factor;
!   TFM_DEPTH (*c) *= scale_factor;
!   TFM_FIX_DEPTH (*c) *= scale_factor;
  }
- 
- /* Make a new TFM character from the information in BB and assign it to
-    `CHARS[CODE]', allocating space if necessary.  */
  
! void
! char_make_tfm (char_type *chars[], charcode_type code,
!                real_bounding_box_type bb)
  {
!   tfm_char_type *new_tfm_char = XTALLOC1 (tfm_char_type);
    
!   TFM_CHAR_EXISTS (*new_tfm_char) = true;
!   TFM_CHARCODE (*new_tfm_char) = code;
!   TFM_WIDTH (*new_tfm_char) = BB_WIDTH (bb);
!   TFM_HEIGHT (*new_tfm_char) = MAX_ROW (bb);
!   TFM_DEPTH (*new_tfm_char) = -MIN_ROW (bb);
!   TFM_ITALIC_CORRECTION (*new_tfm_char) = 0.0;
!   TFM_KERN (*new_tfm_char) = list_init ();
!   TFM_LIGATURE (*new_tfm_char) = list_init ();
! 
!   /* If this character didn't exist in the BZR input, have to define it. */
!   if (chars[code] == NULL)
!     chars[code] = XTALLOC1 (char_type);
!     
!   CHAR_TFM_INFO (*chars[code]) = new_tfm_char;
  }
--- 102,251 ----
    return scaled_p;
  }
+ 
+ /* Merge CCC_CHARS and BZR_CHARS between STARTING_CHAR and ENDING_CHAR,
+    with the latter taking precedence.  For each element in CCC_CHARS we use
+    also incorporate any other characters it needs.  Return the resulting
+    array of structures, and the number of subroutines found in SUBR_COUNT.  */
+    
+ char_type **
+ subr_chars (bzr_char_type *bzr_chars[], ccc_type *ccc_chars[],
+             charcode_type starting_char, charcode_type ending_char,
+             unsigned *subr_count)
+ {
+   unsigned code;
+   char_type **subrs = XTALLOC (MAX_CHARCODE + 1, char_type *);
+   
+   *subr_count = 0;
+   for (code = 0; code <= MAX_CHARCODE; code++)
+     subrs[code] = NULL;
+ 
+   for (code = starting_char; code <= ending_char; code++)
+     {
+       if (ccc_chars[code])
+         *subr_count += update_subrs (subrs, code, ccc_chars, bzr_chars);
+     }
+ 
+   return subrs;
+ }
  
  
! /* Update in SUBRS all the characters in CCC_CHARS and BZR_CHARS that
!    are used as subroutines in CCC_CHARS[CODE].  Prefer entries in
!    BZR_CHARS to ones in CCC_CHARS, if both exist.  We assume
!    CCC_CHARS[CODE] is not null.  */
  
! static unsigned
! update_subrs (char_type *subrs[], charcode_type code,
!               ccc_type *ccc_chars[], bzr_char_type *bzr_chars[])
  {
!   unsigned this_cmd;
!   ccc_type c = *ccc_chars[code];
!   unsigned subr_count = 0;
! 
!   for (this_cmd = 0; this_cmd < LIST_SIZE (c); this_cmd++)
!     { 
!       ccc_cmd_type cmd = *(ccc_cmd_type *) LIST_ELT (c, this_cmd);
!       
!       switch (CCC_OPCODE (cmd))
!         {
!         case TR_SETCHAR:
!         case TR_SETCHARBB:
!           {
!             char_type *new_char = XTALLOC1 (char_type);
!             charcode_type subr_code = CCC_CHARCODE (cmd);
!             
!             /* If we already needed this character, keep going.  */
!             if (subrs[subr_code])
!               continue;
!             
!             /* Prefer the BZR definition to the CCC if we have both.  */
!             if (bzr_chars[subr_code])
!               {
!                 CHAR_CLASS (*new_char) = bzr_char_class;
!                 CHAR_BZR (*new_char) = bzr_chars[subr_code];
!                 subrs[subr_code] = new_char;
!                 subr_count++;
!               }
!             else if (ccc_chars[subr_code])
!               {
!                 CHAR_CLASS (*new_char) = ccc_char_class;
!                 CHAR_CCC (*new_char) = ccc_chars[subr_code];
!                 subrs[subr_code] = new_char;
!                 subr_count++;
!                 
!                 /* This CCC char might need more subroutines, so recurse.  */
!                 subr_count
!                   += update_subrs (subrs, subr_code, ccc_chars, bzr_chars);
!               }
!             else
!               WARNING2 ("Char %d used by CCC char %d, but undefined",
!                         subr_code, code);
!           }
!           break;
! 
!         case TR_HMOVE:
!         case TR_VMOVE:
!           break;
! 
!         default:
!           FATAL2 ("Bad CCC command %d in char %d", CCC_OPCODE (cmd), code);
! 	}
!     }
    
!   return subr_count;
! }
! 
! /* Transform all the coordinates in each spline in the list.  */
! 
! spline_list_array_type
! oblique_splines (spline_list_array_type shape)
! {
!   unsigned this_list;
!   spline_list_array_type answer = new_spline_list_array ();
! 
!   if (oblique_angle == 0.0) return shape;
    
!   for (this_list = 0; this_list < SPLINE_LIST_ARRAY_LENGTH (shape);
!        this_list++)
      {
!       unsigned this_spline;
!       spline_list_type list = SPLINE_LIST_ARRAY_ELT (shape, this_list);
!       spline_list_type *new = new_spline_list ();
! 
!       for (this_spline = 0; this_spline < SPLINE_LIST_LENGTH (list);
!            this_spline++)
!         {
!           spline_type s = SPLINE_LIST_ELT (list, this_spline);
! 
!           START_POINT (s) = slant_point (START_POINT (s));
!           END_POINT (s) = slant_point (END_POINT (s));
!           
!           if (SPLINE_DEGREE (s) == CUBIC)
!             {
!               CONTROL1 (s) = slant_point (CONTROL1 (s));
!               CONTROL2 (s) = slant_point (CONTROL2 (s));
!             }
! 
!           append_spline (new, s);
!         }
        
!       append_spline_list (&answer, *new);
      }
+   free_spline_list_array (&shape);
  
!   return answer;
  }
  
! 
! /* Slant the single point P.  This is just trigonometry.  */
! 
! static real_coordinate_type
! slant_point (real_coordinate_type p)
  {
!   real_coordinate_type slanted_p;
!   
!   slanted_p.y = p.y;
!   slanted_p.x = p.x + tan (oblique_angle) * p.y;
    
!   return slanted_p;
  }
diff -Nrc2 fontutils-0.5/bzrto/char.h fontutils-0.6/bzrto/char.h
*** fontutils-0.5/bzrto/char.h	Mon Aug 31 10:24:08 1992
--- fontutils-0.6/bzrto/char.h	Mon Oct 19 10:24:34 1992
***************
*** 21,60 ****
  
  #include "bzr.h"
! #include "tfm.h"
  
  
- /* The representation of a single character.  */
  typedef struct
  {
!   bzr_char_type *bzr_info;
!   tfm_char_type *tfm_info;
  } char_type;
  
! /* The bzr-derived information about the character C.  */
! #define CHAR_BZR_INFO(c) ((c).bzr_info)
! #define BCHAR_BB(c) (BZR_CHAR_BB (*(CHAR_BZR_INFO (c))))
! #define BCHAR_MIN_COL(c) (BZR_CHAR_MIN_COL (*(CHAR_BZR_INFO (c))))
! #define BCHAR_MAX_COL(c) (BZR_CHAR_MAX_COL (*(CHAR_BZR_INFO (c))))
! #define BCHAR_MIN_ROW(c) (BZR_CHAR_MIN_ROW (*(CHAR_BZR_INFO (c))))
! #define BCHAR_MAX_ROW(c) (BZR_CHAR_MAX_ROW (*(CHAR_BZR_INFO (c))))
! #define BCHAR_BB_WIDTH(c) (BZR_CHAR_BB_WIDTH (*(CHAR_BZR_INFO (c))))
! #define BCHAR_SHAPE(c)    (BZR_SHAPE(*(CHAR_BZR_INFO (c))))
! 
! /* The tfm-derived information about the character C.  */
! #define CHAR_TFM_INFO(c) ((c).tfm_info)
! 
! 
! /* Return a pointer to the character CODE.  Return NULL if there is no
!    BZR info for CODE.  */
! extern char_type *get_new_char (charcode_type code);
  
! /* Scale a character by SCALE_FACTOR.  */
! extern void scale_char (char_type *, real scale_factor);
  
  
! /* Create a `tfm_char_type' structure from the information in BB and
!    assign it to `CHARS[CODE]'.  */
! extern void char_make_tfm (char_type *chars[], charcode_type code,
!                            real_bounding_box_type bb);
  
  #endif /* not CHAR_H */
--- 21,58 ----
  
  #include "bzr.h"
! #include "input-ccc.h"
  
+ typedef enum { bzr_char_class, ccc_char_class } char_class_type;
  
  typedef struct
  {
!   char_class_type tag;
!   union
!   {
!     bzr_char_type *bzr_char;
!     ccc_type *ccc_char;
!   } u;
  } char_type;
  
! #define CHAR_CLASS(c) ((c).tag)
! #define CHAR_BZR(c) ((c).u.bzr_char)
! #define CHAR_CCC(c) ((c).u.ccc_char)
  
! 
! /* See char.c.  */
! extern real oblique_angle;
! 
! /* Slant all splines in the list by `oblique_angle'.  */
! extern spline_list_array_type oblique_splines (spline_list_array_type);
  
  
! /* Return an array of which characters are needed by CCC_CHARS (between
!    START and END) as subroutines, and how many we found in SUBR_COUNT.  */
! extern char_type **subr_chars (bzr_char_type *[], ccc_type *ccc_chars[],
!                                charcode_type start, charcode_type end,
!                                unsigned *subr_count);
! 
! /* Scale a character by SCALE_FACTOR.  */
! extern void scale_char (bzr_char_type *, real scale_factor);
  
  #endif /* not CHAR_H */
